Index: /branches/2924_DotNetCoreMigration/HeuristicLab.PluginInfrastructure/3.3/packages.config
===================================================================
--- /branches/2924_DotNetCoreMigration/HeuristicLab.PluginInfrastructure/3.3/packages.config	(revision 16192)
+++ /branches/2924_DotNetCoreMigration/HeuristicLab.PluginInfrastructure/3.3/packages.config	(revision 16192)
@@ -0,0 +1,43 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<packages>
+  <package id="Microsoft.Win32.Registry" version="4.5.0" targetFramework="net47" />
+  <package id="Microsoft.Win32.Registry.AccessControl" version="4.5.0" targetFramework="net47" />
+  <package id="Microsoft.Win32.SystemEvents" version="4.5.0" targetFramework="net47" />
+  <package id="Microsoft.Windows.Compatibility" version="2.0.1" targetFramework="net47" />
+  <package id="System.CodeDom" version="4.5.0" targetFramework="net47" />
+  <package id="System.ComponentModel.Composition" version="4.5.0" targetFramework="net47" />
+  <package id="System.Configuration.ConfigurationManager" version="4.5.0" targetFramework="net47" />
+  <package id="System.Data.DataSetExtensions" version="4.5.0" targetFramework="net47" />
+  <package id="System.Data.Odbc" version="4.5.0" targetFramework="net47" />
+  <package id="System.Data.SqlClient" version="4.5.0" targetFramework="net47" />
+  <package id="System.Diagnostics.EventLog" version="4.5.0" targetFramework="net47" />
+  <package id="System.Diagnostics.PerformanceCounter" version="4.5.0" targetFramework="net47" />
+  <package id="System.DirectoryServices" version="4.5.0" targetFramework="net47" />
+  <package id="System.DirectoryServices.AccountManagement" version="4.5.0" targetFramework="net47" />
+  <package id="System.DirectoryServices.Protocols" version="4.5.0" targetFramework="net47" />
+  <package id="System.Drawing.Common" version="4.5.0" targetFramework="net47" />
+  <package id="System.IO.FileSystem.AccessControl" version="4.5.0" targetFramework="net47" />
+  <package id="System.IO.FileSystem.Primitives" version="4.3.0" targetFramework="net47" />
+  <package id="System.IO.Packaging" version="4.5.0" targetFramework="net47" />
+  <package id="System.IO.Pipes.AccessControl" version="4.5.0" targetFramework="net47" />
+  <package id="System.IO.Ports" version="4.5.0" targetFramework="net47" />
+  <package id="System.Management" version="4.5.0" targetFramework="net47" />
+  <package id="System.Runtime.Caching" version="4.5.0" targetFramework="net47" />
+  <package id="System.Runtime.CompilerServices.Unsafe" version="4.5.0" targetFramework="net47" />
+  <package id="System.Security.AccessControl" version="4.5.0" targetFramework="net47" />
+  <package id="System.Security.Cryptography.Cng" version="4.5.0" targetFramework="net47" />
+  <package id="System.Security.Cryptography.Pkcs" version="4.5.0" targetFramework="net47" />
+  <package id="System.Security.Cryptography.ProtectedData" version="4.5.0" targetFramework="net47" />
+  <package id="System.Security.Cryptography.Xml" version="4.5.0" targetFramework="net47" />
+  <package id="System.Security.Permissions" version="4.5.0" targetFramework="net47" />
+  <package id="System.Security.Principal.Windows" version="4.5.0" targetFramework="net47" />
+  <package id="System.ServiceModel.Duplex" version="4.4.1" targetFramework="net47" />
+  <package id="System.ServiceModel.Http" version="4.4.1" targetFramework="net47" />
+  <package id="System.ServiceModel.NetTcp" version="4.4.1" targetFramework="net47" />
+  <package id="System.ServiceModel.Primitives" version="4.4.1" targetFramework="net47" />
+  <package id="System.ServiceModel.Security" version="4.4.1" targetFramework="net47" />
+  <package id="System.ServiceModel.Syndication" version="4.5.0" targetFramework="net47" />
+  <package id="System.ServiceProcess.ServiceController" version="4.5.0" targetFramework="net47" />
+  <package id="System.Text.Encoding.CodePages" version="4.5.0" targetFramework="net47" />
+  <package id="System.Threading.AccessControl" version="4.5.0" targetFramework="net47" />
+</packages>